; Read in all tokens and do some misc stuff like convert number strings to
;  immediates. Filter out SPACE tokens, convert REG tokens, strip preserve
;  number if present.

;
; DATA
;
C0MAXTOKEN      = 0f8h+1                ; maximum tokens per statement line

EOL             = 0                     ; input token values
SPACE           = 1
BIN_NUM         = 2
DEC_NUM         = 3
HEX_NUM         = 4
ASCIIWORD       = 5
REG             = 6
EQUATE          = 7
L_PAREN         = 8
R_PAREN         = 9
L_BRACKET       = 10
R_BRACKET       = 11
OP_ADD          = 12
OP_SUB          = 13
OP_NOT          = 14
OP_MUL          = 15
OP_DIV          = 16
OP_UMUL         = 17
OP_UDIV         = 18
OP_MOD          = 19
OP_L_SHIFT      = 20
OP_R_SHIFT      = 21
OP_L_SSHIFT     = 22
OP_R_SSHIFT     = 23
OP_L_ROT        = 24
OP_R_ROT        = 25
OP_AND          = 26
OP_XOR          = 27
OP_OR           = 28
AS_SIMPLE       = 29
AS_MUL          = 30
AS_DIV          = 31
AS_UMUL         = 32
AS_UDIV         = 33
AS_MOD          = 34
AS_ADD          = 35
AS_SUB          = 36
AS_AND          = 37
AS_XOR          = 38
AS_OR           = 39
AS_L_SHIFT      = 40
AS_R_SHIFT      = 41
AS_L_SSHIFT     = 42
AS_R_SSHIFT     = 43
AS_L_ROT        = 44
AS_R_ROT        = 45
IMMEDIATE       = 2                     ; BIN_NUM or DEC_NUM or HEX_NUM

align 4
c0token         dd    C0MAXTOKEN dup(?) ; actual token                       |
c0tokenlptr     dd    C0MAXTOKEN dup(?) ; ptr to token lexeme or num or reg  |
c0tokenllen     dd    C0MAXTOKEN dup(?) ; length of token lexeme             |

c0regspreserve  db      ?               ; bitmap of regs to preserve

c0err0          db      'Statement is too long.',CRLFT
c0err1          db      'Constant too large.',CRLFT

;
; CODE
;

;
c0_cheknum:
        mov edx,_iolexemeptr
        mov ecx,_iolexemelen
        cmp eax,BIN_NUM
        je short c0_cheknumf0
        cmp eax,DEC_NUM
        je short c0_cheknumf1
        cmp eax,HEX_NUM
        je short c0_cheknumf2
        stc
        ret
c0_cheknumf3:
        mov eax,IMMEDIATE
        clc
        ret
c0_cheknumf0:
        mov esi,edx
        xor edx,edx
c0_cheknumf0l0:
        lodsb
        sub al,'0'
        cmp al,1
        ja c0_cheknumf3
        shl edx,1
        jc short c0_cheknumerr
        or dl,al
        jmp c0_cheknumf0l0
c0_cheknumf1:
        mov esi,edx
        xor edx,edx
        xor eax,eax
c0_cheknumf1l0:
        lodsb
        sub al,'0'
        cmp al,9
        ja c0_cheknumf3
        shl edx,1
        jc short c0_cheknumerr
        mov ecx,edx
        test edx,0c0000000h
        jnz short c0_cheknumerr
        shl edx,2
        add edx,ecx
        jc short c0_cheknumerr
        add edx,eax
        jc short c0_cheknumerr
        jmp c0_cheknumf1l0
c0_cheknumf2:
        mov esi,edx
        xor edx,edx
c0_cheknumf2l0:
        lodsb
        or al,20h
        sub al,'0'
        cmp al,9
        jbe short c0_cheknumf2l0f0
        sub al,('a'-'0')-10
        cmp al,0fh
        ja c0_cheknumf3
c0_cheknumf2l0f0:
        test edx,0f0000000h
        jnz short c0_cheknumerr
        shl edx,4
        or dl,al
        jmp c0_cheknumf2l0
;-----------------------------------------------------------------------------
c0_cheknumerr:
        add esp,4
        mov edx,offset c0err1
        call _io_error
        jmp _c0

;
_c0:
        call _io_find
        jc _ret
        inc cslinestotal
        mov al,defregspreserve
        mov c0regspreserve,al
        mov edi,4
        call _io_read
        jc _c0
        call c0_cheknum
        jc short c0l0f0
        mov c0regspreserve,dl
        mov defregspreserve,dl
c0l0:
        call _io_read
        jc _c0
c0l0f0:
        cmp eax,SPACE
        je c0l0
        call c0_cheknum
        cmp eax,REG
        jne short c0l0f1
        mov bx,[edx+1]
        or bx,2020h
        mov dl,1
        cmp bl,'a'
        je short c0l0f1
        mov dl,3
        cmp bl,'c'
        je short c0l0f1
        mov dl,5
        cmp bl,'s'
        je short c0l0f1
        mov dl,7
        cmp bh,'p'
        je short c0l0f1
        mov dl,2
        cmp bl,'b'
        je short c0l0f1
        mov dl,4
        cmp bh,'x'
        je short c0l0f1
        mov dl,6
c0l0f1:
        cmp eax,OP_L_SSHIFT
        jne short c0l0f2
        mov eax,OP_L_SHIFT
c0l0f2:
        mov c0tokenlptr[edi],edx
        mov c0tokenllen[edi],ecx
        mov c0token[edi],eax
        cmp eax,EOL
        je short c0f0
        add edi,4
        cmp edi,C0MAXTOKEN*4
        jb c0l0
        mov edx,offset c0err0
        call _io_error
        jmp _c0
c0f0:
        clc
        ret

