; Optimize intermediate ideal assembly code.

;
; DATA
;
C2MAXTMP        = 088h                  ; max number of temporary vars ever

align 4
c2optbl         dd      c2abs,c2neg,c2not,c2imul,c2idiv,c2mul,c2div,c2mod
                dd      c2add,c2sub,c2shl,c2shr,c2sar,c2rol,c2ror
                dd      c2and,c2xor,c2or,c2mov

c2vard          db   16*C2MAXTMP dup(?) ; var data during optimization

c2undooptbl     db      ?,?, C1ABS,C1NEG,C1NOT,C1IDIV,C1IMUL,C1DIV,C1MUL
                db      C1MOD,C1SUB,C1ADD,C1SHR,C1SHL,C1SHL,C1ROR,C1ROL
                db      C1AND,C1XOR,C1OR,C1MOV
c2undodotbl     db      ?,?, 0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,0,1,0,0

c2modified      db      ?
c2addtoself     db      ?

c2err0          db      'Division by 0.',CRLFT

;
; CODE
;

@setmodified    macro
        mov c2modified,1
endm

@tmpaddx        macro   src,failjmpaddx
        movzx esi,byte ptr &src
        sub esi,8
        jc &failjmpaddx
        lea esi,[esi*4]
        lea esi,[esi*4+offset c2vard+2]
endm

;
_c2:
        mov oldstackptr,esp

c2l0:
        mov edi,offset c2vard
        mov ecx,C2MAXTMP
        xor eax,eax
c2l1:
        mov [edi],ax
        mov [edi+12],eax
        add edi,16
        loop c2l1
        mov c2modified,al
        mov ebp,offset c1ins

c2l2:
        mov al,[ebp]
        cmp al,C1EOL
        je short c2l2d
        cmp al,C1NOP
        je short c2l2c
        push offset c2l2f0
        cmp al,C1NOT
        ja c2bin
        jmp c2una
c2l2f0:
        cmp byte ptr [ebp],C1NOP
        jbe short c2l2c
        call c2undo
c2l2c:
        add ebp,22
        jmp c2l2

c2l2d:
        mov esi,offset c2vard
        mov ecx,C2MAXTMP
c2l3:
        cmp byte ptr [esi],0
        jne short c2l3c
        mov edi,[esi+12]
        or edi,edi
        jz short c2l3c
        mov byte ptr [edi],C1NOP
        @setmodified
c2l3c:
        add esi,16
        loop c2l3
        cmp c2modified,0
        jne c2l0
        clc
        ret

;
c2bin:
        lea edi,[ebp+12]
        call c2replace
c2una:
        lea edi,[ebp+2]
        cmp byte ptr [edi],0
        je short c2binf0
        call c2replace
c2binf0:

        cmp byte ptr [ebp+2],0
        jne _ret
        @tmpaddx [ebp+5],_ret

        movzx eax,byte ptr [ebp]
        jmp c2optbl[eax*4-C1ABS*4]

;-----------------------------------------------------------------------------
c2abs:
        call c2r5
        or eax,eax
        jns short c2absf0
        neg eax
c2absf0:
        jmp c2r6
;-----------------------------------------------------------------------------
c2neg:
        call c2r5
        neg eax
        jmp c2r6
;-----------------------------------------------------------------------------
c2not:
        call c2r5
        not eax
        jmp c2r6
;-----------------------------------------------------------------------------
c2imul:
        movzx edx,word ptr [esi+4]
        mov ecx,[ebp+18]
        mov ebx,[esi]
        mov eax,[ebp+12]

        or eax,eax
        jnz c2imulf0
        cmp word ptr [ebp+16],0
        jne c2imulf0
        cmp ecx,1
        jb c2ra
        je c2r8f0

        or edx,edx
        jnz c2imulf4
        or bl,bl
        jnz c2imulf4
        cmp byte ptr [esi-1],0
        je c2imulf4
        mov eax,[esi+6]
        or ebx,ebx
        jnz short c2imulf1
        imul eax,ecx
        jmp c2r6
c2imulf1:
        cmp ecx,9
        ja c2r0
        mov edx,ecx
        mov bl,1
        shld ecx,ebx,16
        or bh,bh
        jz short c2imulf2
        shl bl,cl
        or ch,ch
        jz short c2imulf3
        cmp ch,bh
        jne c2r0
        inc bl
c2imulf3:
        mov ch,bh
c2imulf2:
        xchg ebx,eax
        movzx eax,al
        mul dl
        imul edx,ebx
        mov bl,ch
        mov bh,al
        xor ecx,ecx
        xor eax,eax
        call c2r4
        jc c2r0
        mov [ebp+13],ax
        mov [ebp+15],cl
        mov [ebp+18],edx
        jmp c2r6f0

c2imulf0:
        cmp byte ptr [esi-1],0
        je c2r0
        or ebx,ebx
        jnz c2r0
        or edx,edx
        jnz c2r0

        mov ebx,eax
        mov eax,ecx
        mov ecx,[esi+6]
        cmp ecx,1
        jb c2ra
        je c2r6f0

        movzx edx,word ptr [ebp+16]
        mov edi,[esi+10]
        mov [edi+12],ebx
        mov [esi],ebx
        mov [edi+16],dx
        mov [esi+4],dx
        mov [edi+18],eax
        mov [esi+6],eax
        mov dword ptr [ebp+12],0
        mov word ptr [ebp+16],0
        mov [ebp+18],ecx

        or bl,bl
        jnz c2r0
        or edx,edx
        jz c2imulf1
        jmp c2r0

c2imulf4:
        cmp ecx,9
        ja short c2imulf5
        xor ebx,ebx
        mov al,[ebp+5]
        btr ecx,0
        jnc short c2imulf6
        mov bl,al
c2imulf6:
        bsf edx,ecx
        btr ecx,edx
        or ecx,ecx
        jnz c2r0
        mov ah,dl
        mov [ebp+13],ax
        mov [ebp+15],bl
        mov dword ptr [ebp+18],0
        mov byte ptr [ebp],C1MOV
        @setmodified
        jmp c2bin
c2imulf5:
        bsf eax,ecx
        bsr ebx,ecx
        cmp eax,ebx
        jne c2r0
        mov [ebp+18],eax
        mov byte ptr [ebp],C1SHL
        @setmodified
        jmp c2shl
;-----------------------------------------------------------------------------
c2idiv:
        call c2rg
        jc short c2idivf0
        or edx,ebx
        jz short c2idivf1
        cmp eax,ecx
        jne c2r0
        jmp c2rh
c2idivf1:
        cdq
        idiv ecx
        xor edx,edx
        jmp c2r6
c2idivf0:
        cmp dl,0fdh
        ja short c2idivf2
        je short c2idivf3
        movzx eax,dl
        xor edx,edx
        xor ebx,ebx
        jmp c2r6
c2idivf2:
        cmp dl,0feh
        ja c2r8f0
        jmp c2rh
c2idivf3:
        mov [ebp+18],edi
        mov byte ptr [ebp],C1SAR
        @setmodified
        jmp c2sar
;-----------------------------------------------------------------------------
c2mul:
        jmp c2imul
;-----------------------------------------------------------------------------
c2div:
        call c2rg
        jc short c2divf0
        or edx,ebx
        jz short c2divf1
        cmp eax,ecx
        jne c2r0
        jmp c2rh
c2divf1:
        xor edx,edx
        div ecx
        xor edx,edx
        jmp c2r6
c2divf0:
        cmp dl,0fdh
        ja short c2divf2
        je short c2divf3
        movzx eax,dl
        xor edx,edx
        xor ebx,ebx
        jmp c2r6
c2divf2:
        cmp dl,0feh
        ja c2r8f0
        jmp c2rh
c2divf3:
        mov [ebp+18],edi
        mov byte ptr [ebp],C1SHR
        @setmodified
        jmp c2shr
;-----------------------------------------------------------------------------
c2mod:
        call c2rg
        jc short c2modf0
        or edx,ebx
        jz short c2modf1
        cmp eax,ecx
        jne c2r0
        jmp c2ra
c2modf1:
        xor edx,edx
        div ecx
        mov eax,edx
        xor edx,edx
        jmp c2r6
c2modf0:
        cmp dl,0feh
        jae c2ra
        cmp dl,0fdh
        je short c2modf2
        or dl,dl
        jnz c2ra
        jmp c2r8f0
c2modf2:
        mov eax,-1
        mov ecx,edi
        shl eax,cl
        xor eax,-1
        mov [ebp+18],eax
        mov byte ptr [ebp],C1AND
        @setmodified
        jmp c2and
;-----------------------------------------------------------------------------
c2add:
        cmp byte ptr [ebp+12],0
        jne c2r0
        cmp byte ptr [esi-1],0
        sete al
        cmp byte ptr [esi],0
        setne ah
        or al,ah
        mov cx,[ebp+16]
        call c2r2
        setc ah
        or al,ah
        mov c2addtoself,al

c2addf5:
        xor edx,edx
        xor ebx,ebx
        mov ax,[ebp+13]
        call c2r3
        movzx eax,byte ptr [ebp+15]
        call c2r3
        cmp c2addtoself,0
        jne short c2addf2
        mov al,[esi+3]
        call c2r3
        jc short c2addf6
        mov ax,[esi+1]
        call c2r3
        jnc short c2addf0
c2addf6:
        mov c2addtoself,1
        jmp c2addf5
c2addf2:
        mov al,[ebp+5]
        call c2r3
        jc c2r0
c2addf0:

        xor ecx,ecx
        xor eax,eax
        call c2r4
        jc short c2addf7
        mov ebx,edx
        call c2r4
        jnc short c2addf1
c2addf7:
        cmp c2addtoself,0
        je c2addf6
        jmp c2r0
c2addf1:

        mov [ebp+13],ax
        mov [ebp+15],cl
        cmp c2addtoself,0
        jne short c2addf3
        mov ax,[esi+4]
        or [ebp+16],ax
        mov eax,[esi+6]
        add [ebp+18],eax
        jmp short c2addf4
c2addf3:
        mov byte ptr [esi-2],1
c2addf4:
        mov byte ptr [ebp],C1MOV
        @setmodified
        jmp c2mov
;-----------------------------------------------------------------------------
c2sub:
        cmp byte ptr [ebp+12],0
        jne c2r0
        cmp byte ptr [esi-1],0
        je c2r0
        cmp byte ptr [esi],0
        jne c2r0

        xor edx,edx
        xor ebx,ebx
        mov ax,[esi+1]
        call c2r3
        movzx eax,byte ptr [esi+3]
        call c2r3
        mov ax,[ebp+13]
        call c2rf
        movzx eax,byte ptr [ebp+15]
        call c2rf

        xor ecx,ecx
        xor eax,eax
        call c2r4
        jc c2r0
        mov ebx,edx
        call c2r4
        jc c2r0

        mov bx,[esi+4]
        mov dx,[ebp+16]
        or dl,dl
        jz short c2subf0
        sub bl,dl
        jnz c2r0
c2subf0:
        or dh,dh
        jz short c2subf1
        sub bh,dh
        jnz c2r0
c2subf1:
        mov [ebp+16],bx
        mov [ebp+13],ax
        mov [ebp+15],cl
        mov eax,[esi+6]
        sub eax,[ebp+18]
        mov [ebp+18],eax
        mov byte ptr [ebp],C1MOV
        @setmodified
        jmp c2mov
;-----------------------------------------------------------------------------
c2shl:
        call c2r7
        call c2r8
        call c2r5f1
        mov ebx,[esi]
        or bl,bl
        jnz c2r0
        test ebx,0ff000000h
        jz short c2shlf0
        test ebx,000ffff00h
        jnz c2r0
        shr ebx,16
c2shlf0:
        or bh,bh
        jz short c2shlf1
        ror ebx,8
	add bh,cl
	cmp bh,3
	ja c2r0
	rol ebx,8
c2shlf1:
        shl eax,cl
	jmp c2r6
;-----------------------------------------------------------------------------
c2shr:
        call c2r7
        call c2r8
        call c2re
        shr eax,cl
        jmp c2r6
;-----------------------------------------------------------------------------
c2sar:
        call c2r7
        call c2r8
        call c2re
        sar eax,cl
        jmp c2r6
;-----------------------------------------------------------------------------
c2rol:
        call c2r7
        call c2r8
        call c2r5
        rol eax,cl
        jmp c2r6
;-----------------------------------------------------------------------------
c2ror:
        call c2r7
        call c2r8
        call c2r5
        ror eax,cl
        jmp c2r6
;-----------------------------------------------------------------------------
c2and:
        call c2rc
        jc short c2andf0
        or ecx,ecx
        jz c2ra
        cmp ecx,-1
        je c2r8f0
c2andf0:
        call c2r9
        jc c2r8f0
        and eax,ecx
        jmp c2r6
;-----------------------------------------------------------------------------
c2xor:
        call c2rc
        jc short c2xorf0
        or ecx,ecx
        jz c2r8f0
        cmp ecx,-1
        je c2rd
c2xorf0:
        call c2r9
        jc c2ra
        xor eax,ecx
        jmp c2r6
;-----------------------------------------------------------------------------
c2or:
        call c2rc
        jc short c2orf0
        or ecx,ecx
        jz c2r8f0
        cmp ecx,-1
        je c2rb
c2orf0:
        call c2r9
        jc c2r8f0
        or eax,ecx
        jmp c2r6
;-----------------------------------------------------------------------------
c2mov:
        cmp byte ptr [esi-2],0
        jne short c2movf0
        mov edi,[esi+10]
        or edi,edi
        jz short c2movf0
        mov byte ptr [edi],C1NOP
        @setmodified
c2movf0:
        mov [esi+10],ebp
        mov word ptr [esi-2],100h
        mov eax,[ebp+12]
        mov [esi],eax
        mov eax,[ebp+16]
        mov [esi+4],eax
        mov ax,[ebp+20]
        mov [esi+8],ax
        ret

;
c2replace:
        mov edx,[edi+6]
        mov cx,[edi+4]
        mov bl,[edi]

c2replacei:
        @tmpaddx [edi+1],c2replaceid
        cmp byte ptr [esi-1],0
        je c2replaceic
        mov bh,[esi]
        or bh,bh
        jz short c2replaceii
c2replaceim:
        or bl,bl
        jnz c2replaceic
        or cx,cx
        jnz c2replaceic
        or edx,edx
        jnz c2replaceic
        cmp word ptr [edi+2],0
        jne c2replaceic
        mov edx,[esi+6]
        mov cx,[esi+4]
        mov ebx,[esi]
        mov [edi],ebx
        @setmodified
        jmp short c2replaceid
c2replaceii:
        mov bh,[esi+3]
        mov ax,[esi+1]
        cmp byte ptr [edi+2],0
        je short c2replaceiif0
        call c2r1
        jc short c2replaceic
        or bh,bh
        jz short c2replaceiif3
        or ax,ax
        jnz short c2replaceic
        mov al,bh
c2replaceiif3:
        mov bh,[edi+2]
        add ah,bh
        cmp ah,3
        ja short c2replaceic
        push eax ecx
        mov cl,bh
        mov eax,[esi+6]
        shl eax,cl
        sub eax,[esi+6]
        add edx,eax
        pop ecx eax
        jmp short c2replaceiif2
c2replaceiif0:
        call c2r2
        jc short c2replaceic
        cmp byte ptr [edi+3],0
        jz short c2replaceiif1
        or bh,bh
        jz short c2replaceiif2
        or ax,ax
        jnz short c2replaceic
        mov al,bh
        jmp short c2replaceiif2
c2replaceiif1:
        mov [edi+3],bh
c2replaceiif2:
        mov [edi+1],ax
        add edx,[esi+6]
        or cx,[esi+4]
        @setmodified
        jmp short c2replaceid
c2replaceic:
        mov byte ptr [esi-2],1
c2replaceid:

c2replaceb:
        @tmpaddx [edi+3],c2replacebd
        cmp byte ptr [esi-1],0
        je c2replacebc
        mov bh,[esi]
        or bh,bh
        jz short c2replacebi
c2replacebm:
        or bl,bl
        jnz c2replacebc
        or cx,cx
        jnz short c2replacebc
        or edx,edx
        jnz short c2replacebc
        cmp word ptr [edi+1],0
        jne short c2replacebc
        mov edx,[esi+6]
        mov cx,[esi+4]
        mov ebx,[esi]
        mov [edi],ebx
        @setmodified
        jmp short c2replacebd
c2replacebi:
        call c2r2
        jc short c2replacebc
        mov bh,[esi+3]
        mov ax,[esi+1]
        cmp word ptr [edi+1],0
        je short c2replacebif0
        or bh,ah
        jnz short c2replacebc
        mov bh,al
        jmp short c2replacebif1
c2replacebif0:
        mov [edi+1],ax
c2replacebif1:
        mov [edi+3],bh
        add edx,[esi+6]
        or cx,[esi+4]
        @setmodified
        jmp short c2replacebd
c2replacebc:
        mov byte ptr [esi-2],1
c2replacebd:

        mov [edi+6],edx
        mov [edi+4],cx
        mov [edi],bl
        ret

;
c2undo:
        mov edi,ebp
        movzx edx,byte ptr [ebp]
        mov al,c2undooptbl[edx]
c2undol0:
        sub edi,22
        cmp edi,offset c1ins
        jb _ret
        push edi
        add edi,2
        lea esi,[ebp+2]
        mov ecx,5
        repe cmpsw
        pop edi
        jne c2undol0
        mov ah,[edi]
        cmp ah,C1NOP
        je c2undol0
        cmp ah,al
        jne _ret

        @tmpaddx [ebp+3],c2undof4
        cmp ebp,[esi+10]
        je short c2undof4
        cmp edi,[esi+10]
        jbe _ret
c2undof4:
        @tmpaddx [ebp+5],c2undof5
        cmp ebp,[esi+10]
        je short c2undof5
        cmp edi,[esi+10]
        jbe _ret
c2undof5:

        cmp dl,C1NOT
        jbe short c2undof0

        @tmpaddx [ebp+13],c2undof2
        cmp edi,[esi+10]
        jbe _ret
c2undof2:
        @tmpaddx [ebp+15],c2undof3
        cmp edi,[esi+10]
        jbe _ret
c2undof3:
        add edi,12
        lea esi,[ebp+12]
        mov ecx,5
        repe cmpsw
        jne _ret
        sub edi,22

c2undof0:
        mov byte ptr [ebp],C1NOP
        cmp c2undodotbl[edx],0
        je short c2undof1
        mov byte ptr [edi],C1NOP
c2undof1:
        @setmodified
        cmp byte ptr [ebp+2],0
        jne _ret
        @tmpaddx [ebp+5],_ret
        mov word ptr [esi-2],0
        mov dword ptr [esi+10],0
        ret

;
c2r0:
        mov [esi+10],ebp
        mov word ptr [esi-2],0
        ret
;-----------------------------------------------------------------------------
c2r1:
        cmp byte ptr [esi+4],1
        cmc
        jc _ret
        cmp byte ptr [esi+5],1
        cmc
        ret
;-----------------------------------------------------------------------------
c2r2:
        or cl,cl
        jz short c2r2f0
        cmp byte ptr [esi+4],0
        jz short c2r2f0
c2r2f2:
        stc
        ret
c2r2f0:
        or ch,ch
        jz short c2r2f1
        cmp byte ptr [esi+5],0
        jnz c2r2f2
c2r2f1:
        clc
        ret
;-----------------------------------------------------------------------------
; Add r/t AL 2^AH times to BL (BH is count) or DL (DH is count) if same.
c2r3:
        or al,al
        jz c2r2f1
        mov cl,ah
        mov ch,1
        shl ch,cl
        or bl,bl
        jz short c2r3f0
        cmp al,bl
        jne short c2r3f1
c2r3f0:
        mov bl,al
        add bh,ch
        ret
c2r3f1:
        or dl,dl
        jz short c2r3f2
        cmp al,dl
        je short c2r3f2
        stc
        ret
c2r3f2:
        mov dl,al
        add dh,ch
        ret
;-----------------------------------------------------------------------------
; Distribute BL BH times to AL (2^AH is count) or CL (count is always 1).
c2r4:
        or bl,bl
        jz c2r2f1
        or bh,bh
        jz c2r2f1
        or cl,cl
        jnz short c2r4f0
        test bh,1
        jz short c2r4f0
        mov cl,bl
        and bh,0feh
        jz c2r2f1
c2r4f0:
        or al,al
        jnz c2r2f2
        bsr eax,ebx
        btr ebx,eax
        sub al,8
        test al,0fch
        jnz c2r2f2
        mov ah,al
        mov al,bl
        or bh,bh
        jz c2r2f1
        jmp c2r2f2
;-----------------------------------------------------------------------------
c2r5:
        mov ebx,[esi]
        or ebx,ebx
        jnz c2r5f0
c2r5f1:
        cmp byte ptr [esi-1],0
        je short c2r5f0
        mov dx,[esi+4]
        or dx,dx
        jnz c2r5f0
        mov eax,[esi+6]
        ret
c2r5f0:
        add esp,4
        jmp c2r0
;-----------------------------------------------------------------------------
c2r6:
        mov [ebp+12],ebx
        mov [ebp+16],dx
        mov [ebp+18],eax
c2r6f0:
        mov byte ptr [ebp],C1MOV
        @setmodified
        jmp c2mov
;-----------------------------------------------------------------------------
c2r7:
        cmp dword ptr [ebp+12],0
        jne c2r5f0
        cmp word ptr [ebp+16],0
        jne c2r5f0
        mov ecx,[ebp+18]
        ret
;-----------------------------------------------------------------------------
c2r8:
        and cl,1fh
        jnz _ret
        add esp,4
c2r8f0:
        mov byte ptr [ebp],C1NOP
        @setmodified
        ret
;-----------------------------------------------------------------------------
c2r9:
        cmp byte ptr [esi-1],0
        je c2r5f0
        mov ebx,[esi]
        mov dx,[esi+4]
        mov eax,[esi+6]
        cmp ebx,[ebp+12]
        jne c2r5f0
        cmp dx,[ebp+16]
        jne c2r5f0
        cmp eax,ecx
        jne short c2r9f0
        stc
        ret
c2r9f0:
        or ebx,ebx
        jnz c2r5f0
        or dx,dx
        jnz c2r5f0
        clc
        ret
;-----------------------------------------------------------------------------
c2ra:
        xor edx,edx
        xor ebx,ebx
        xor eax,eax
        jmp c2r6
;-----------------------------------------------------------------------------
c2rb:
        xor edx,edx
        xor ebx,ebx
        mov eax,0ffffffffh
        jmp c2r6
;-----------------------------------------------------------------------------
c2rc:
        mov ecx,[ebp+18]
        cmp dword ptr [ebp+12],0
        jne c2r2f2
        cmp word ptr [ebp+16],0
        jne c2r2f2
        clc
        ret
;-----------------------------------------------------------------------------
c2rd:
        mov byte ptr [ebp],C1NOT
        @setmodified
        jmp c2not
;-----------------------------------------------------------------------------
c2re:
        cmp byte ptr [esi-1],0
        je c2r5f0
        mov ebx,[esi]
        test ebx,0ff0000ffh
        jnz c2r5f0
        mov dx,[esi+4]
        or dx,dx
        jnz c2r5f0
        ror ebx,8
        or bx,bx
        jz short c2ref0
        sub bh,cl
        jc c2r5f0
c2ref0:
        rol ebx,8
        mov eax,[esi+6]
        ret
;-----------------------------------------------------------------------------
; Remove r/t AL 2^AH times from BL (BH is count) or DL (DH is count) if same.
c2rf:
        or al,al
        jz _ret
        mov cl,ah
        mov ch,1
        shl ch,cl
        cmp al,bl
        jne short c2rff0
        sub bh,ch
        jc c2r5f0
        ret
c2rff0:
        cmp al,dl
        jne c2r5f0
        sub dh,ch
        jc c2r5f0
        ret
;-----------------------------------------------------------------------------
c2rg:
        movzx edx,word ptr [esi+4]
        mov ecx,[ebp+18]
        mov ebx,[esi]
        mov eax,[ebp+12]

        or eax,eax
        jnz short c2rgf2
        cmp word ptr [ebp+16],0
        jne short c2rgf2
        cmp ecx,1
        jb short c2rgf3
        je short c2rgf7
        bsf eax,ecx
        bsr edi,ecx
        cmp edi,eax
        mov eax,0
        jne short c2rgf2
        mov dl,0fdh
        stc
        ret
c2rgf7:
        mov dl,0ffh
        stc
        ret
c2rgf3:
        mov edx,offset c2err0
        jmp c1_error
c2rgf2:
        cmp byte ptr [esi-1],0
        je c2r5f0
        cmp eax,ebx
        jne short c2rgf6
        cmp ecx,[esi+6]
        jne short c2rgf6
        cmp dx,[ebp+16]
        jne short c2rgf6
        mov dl,0feh
        stc
        ret
c2rgf6:
        cmp byte ptr [esi],0
        jne c2r5f0
        or ebx,ebx
        jnz short c2rgf1
        cmp dword ptr [esi+6],0
        jne short c2rgf1
        add esp,4
        jmp c2ra
c2rgf1:

        or al,al
        jnz c2r5f0
        cmp dx,[ebp+16]
        jne c2r5f0

        cmp ebx,eax
        je short c2rgf0
        rol ebx,16
        cmp ebx,eax
        je short c2rgf0
        or edx,edx
        jnz c2r5f0

        call c2ri
        mov ebx,eax
        rol ebx,16
        mov dl,dh
        mov al,ch
        call c2ri
        cmp ch,al
        jne c2r5f0

        movzx ebx,dx
        mov eax,[esi+6]
        mov ecx,[ebp+18]
        call c2rj
        jne short c2rgf4
        movzx ebx,dl
c2rgf5:
        imul ecx,ebx
        cmp ecx,eax
        jne c2r5f0
        stc
        ret
c2rgf4:
        xchg bl,bh
        call c2rj
        jne c2r5f0
        xchg ecx,eax
        xchg dl,dh
        movzx ebx,dh
        jmp c2rgf5

c2rgf0:
        mov eax,[esi+6]
        clc
        ret
;-----------------------------------------------------------------------------
c2rh:
        xor edx,edx
        xor ebx,ebx
        mov eax,1
        jmp c2r6
;-----------------------------------------------------------------------------
c2ri:
        xor dh,dh
        or bh,bh
        jz short c2rif1
        inc dh
        mov ch,bh
        rol ebx,8
        or bx,bx
        jz _ret
        cmp bl,ch
        jne short c2rif0
c2rif2:
        mov bl,1
        mov cl,bh
        shl bl,cl
        add dh,bl
        ret
c2rif1:
        rol ebx,8
        mov ch,bl
        or bx,bx
        jnz c2rif2
c2rif0:
        add esp,8
        jmp c2r0
;-----------------------------------------------------------------------------
c2rj:
        mov edx,2
        cmp bx,102h
        je _ret
        cmp bx,204h
        je _ret
        cmp bx,408h
        je _ret
        mov dl,3
        cmp bx,103h
        je _ret
        cmp bx,309h
        je _ret
        mov dl,4
        cmp bx,104h
        je _ret
        cmp bx,208h
        je _ret
        mov dl,5
        cmp bx,105h
        je _ret
        mov dl,8
        cmp bx,108h
        je _ret
        mov dl,9
        cmp bx,109h
        ret

