; Hard-coded lexical analyzer.

        .386p
code32  segment para public use32
        assume cs:code32, ds:code32

include pmode.inc

public  _lexdbaseptr, _lexdendptr

public  _lex_findtoken

;
; DATA
;
EOL             = 0                     ; input token values
SPACE           = 1
BIN_NUM         = 2
DEC_NUM         = 3
HEX_NUM         = 4
ASCIIWORD       = 5
REG             = 6
EQUATE          = 7
L_PAREN         = 8
R_PAREN         = 9
L_BRACKET       = 10
R_BRACKET       = 11
OP_ADD          = 12
OP_SUB          = 13
OP_NOT          = 14
OP_MUL          = 15
OP_DIV          = 16
OP_UMUL         = 17
OP_UDIV         = 18
OP_MOD          = 19
OP_L_SHIFT      = 20
OP_R_SHIFT      = 21
OP_L_SSHIFT     = 22
OP_R_SSHIFT     = 23
OP_L_ROT        = 24
OP_R_ROT        = 25
OP_AND          = 26
OP_XOR          = 27
OP_OR           = 28
AS_SIMPLE       = 29
AS_MUL          = 30
AS_DIV          = 31
AS_UMUL         = 32
AS_UDIV         = 33
AS_MOD          = 34
AS_ADD          = 35
AS_SUB          = 36
AS_AND          = 37
AS_XOR          = 38
AS_OR           = 39
AS_L_SHIFT      = 40
AS_R_SHIFT      = 41
AS_L_SSHIFT     = 42
AS_R_SSHIFT     = 43
AS_L_ROT        = 44
AS_R_ROT        = 45

align 4
_lexdbaseptr    dd      ?               ; start of data in mem
_lexdendptr     dd      ?               ; end of data in mem

j00     dd      52 dup(l29),l30,l30,8 dup(l26),l24,l24,l28,l22,l20,l19
        dd      l18,l17,l16,l15,l14,l13,l12,l11,l10,l09,l08,l07,l06,l02,l01

t00     db      ' :()[]+-~*/%&^|=<>;0123456789eE@_abcdfghijklmnopqrstuvwxyzABCDFGHIJKLMNOPQRSTUVWXYZ'

;
; CODE
;

lc              macro   token
        cmp esi,ebp
        jae ld
        mov edx,&token
        mov ebx,esi
endm

;
; Find any token within LANGUAGE at location (returns longest token found)
; In:
;   EDX -> location within file to search at
; Out:
;   CF=0 - token found at this location
;     EAX - token
;     ECX - length of lexeme
;   CF=1 - no token here or location outside data bounds
;     ECX - ?
;
_lex_findtoken:
        cmp edx,_lexdbaseptr
        jc _ret
        cmp edx,_lexdendptr
        cmc
        jc _ret

        push ebx edx esi edi ebp
        mov ebp,_lexdendptr
        mov esi,edx
        mov ebx,edx
        mov edx,eax
        jmp l00

ld:
        mov ecx,ebx
        mov eax,edx
        pop ebp edi esi edx ebx
        sub ecx,edx
        cmp ecx,1
        ret

l22:
        lodsb
        cmp al,'>'
        jne ld
        lc OP_R_SHIFT
        lodsb
        cmp al,'='
        je short l23
        cmp al,'>'
        jne ld
        lc OP_R_ROT
        lodsb
        cmp al,'='
        jne ld
        lc AS_R_ROT
        jmp ld
l23:
        lc AS_R_SHIFT
        jmp ld
l20:
        lodsb
        cmp al,'<'
        jne ld
        lc OP_L_SHIFT
        lodsb
        cmp al,'='
        je short l21
        cmp al,'<'
        jne ld
        lc OP_L_ROT
        lodsb
        cmp al,'='
        jne ld
        lc AS_L_ROT
        jmp ld
l21:
        lc AS_L_SHIFT
        jmp ld
l19:
        lc AS_SIMPLE
        jmp ld
l16:
        lc OP_AND
        lodsb
        cmp al,'='
        jne ld
        lc AS_AND
        jmp ld
l17:
        lc OP_XOR
        lodsb
        cmp al,'='
        jne ld
        lc AS_XOR
        jmp ld
l18:
        lc OP_OR
        lodsb
        cmp al,'='
        jne ld
        lc AS_OR
        jmp ld
l13:
        lc OP_MUL
        lodsb
        cmp al,'='
        jne ld
        lc AS_MUL
        jmp ld
l14:
        lc OP_DIV
        lodsb
        cmp al,'='
        jne ld
        lc AS_DIV
        jmp ld
l15:
        lc OP_MOD
        lodsb
        cmp al,'='
        jne ld
        lc AS_MOD
        jmp ld
l12:
        lc OP_NOT
        jmp ld
l06:
        lc L_PAREN
        jmp ld
l07:
        lc R_PAREN
        jmp ld
l08:
        lc L_BRACKET
        jmp ld
l09:
        lc R_BRACKET
        jmp ld
l10:
        lc OP_ADD
        lodsb
        cmp al,'='
        jne ld
        lc AS_ADD
        jmp ld
l11:
        lc OP_SUB
        lodsb
        cmp al,'='
        jne ld
        lc AS_SUB
        jmp ld
l01:
        lc SPACE
        lodsb
        cmp al,' '
        je l01
        jmp ld
l03:
        lc OP_UMUL
        lodsb
        cmp al,'='
        jne ld
        lc AS_UMUL
        jmp ld
l04:
        lc OP_UDIV
        lodsb
        cmp al,'='
        jne ld
        lc AS_UDIV
        jmp ld
l05:
        lodsb
        cmp al,'<'
        jne ld
        lc OP_L_SSHIFT
        lodsb
        cmp al,'='
        jne ld
        lc AS_L_SSHIFT
        jmp ld
l02:
        lc EQUATE
        lodsb
        cmp al,'*'
        je l03
        cmp al,'/'
        je l04
        cmp al,'<'
        je l05
        cmp al,'>'
        jne ld
        lodsb
        cmp al,'>'
        jne ld
        lc OP_R_SSHIFT
        lodsb
        cmp al,'='
        jne ld
        lc AS_R_SSHIFT
        jmp ld
l00:
        lodsb
        mov edi,offset t00
        mov ecx,83
        repne scasb
        jne ld
        jmp j00[ecx*4]
l24:
        lc DEC_NUM
        lodsb
        cmp al,'0'
        jb ld
        cmp al,'2'
        jb l24
        cmp al,'9'
        jbe l26
        or al,20h
        cmp al,'b'
        jne short l25
        lc BIN_NUM
        jmp l27
l25:
        cmp al,'a'
        jb ld
        cmp al,'f'
        jbe l27
        cmp al,'h'
        jne ld
        lc HEX_NUM
        jmp ld
l26:
        lc DEC_NUM
        lodsb
        cmp al,'0'
        jb ld
        cmp al,'9'
        jbe l26
        or al,20h
        cmp al,'a'
        jb ld
        cmp al,'f'
        jbe l27
        cmp al,'h'
        jne ld
        lc HEX_NUM
        jmp ld
l27:
        lodsb
        cmp al,'0'
        jb ld
        cmp al,'9'
        jbe l27
        or al,20h
        cmp al,'a'
        jb ld
        cmp al,'f'
        jbe l27
        cmp al,'h'
        jne ld
        lc HEX_NUM
        jmp ld
l28:
        lc EOL
        jmp ld
l29:
        lc ASCIIWORD
l36:
        lodsb
        cmp al,'.'
        je l29
        cmp al,'_'
        je l29
        cmp al,'@'
        je l29
        cmp al,'0'
        jb ld
        cmp al,'9'
        jbe l29
        or al,20h
        cmp al,'a'
        jb ld
        cmp al,'z'
        jbe l29
        jmp ld
l30:
        lc ASCIIWORD
        lodsb
        cmp al,'.'
        je l29
        cmp al,'_'
        je l29
        cmp al,'@'
        je l29
        cmp al,'0'
        jb ld
        cmp al,'9'
        jbe l29
        or al,20h
        cmp al,'a'
        jb ld
        je l31
        cmp al,'b'
        je l32
        cmp al,'c'
        je l31
        cmp al,'d'
        je l33
        cmp al,'s'
        je l34
        cmp al,'z'
        jbe l29
        jmp ld
l31:
        lc ASCIIWORD
        lodsb
        cmp al,'.'
        je l29
        cmp al,'_'
        je l29
        cmp al,'@'
        je l29
        cmp al,'0'
        jb ld
        cmp al,'9'
        jbe l29
        or al,20h
        cmp al,'a'
        jb ld
        cmp al,'x'
        je l35
        cmp al,'z'
        jbe l29
        jmp ld
l32:
        lc ASCIIWORD
        lodsb
        cmp al,'.'
        je l29
        cmp al,'_'
        je l29
        cmp al,'@'
        je l29
        cmp al,'0'
        jb ld
        cmp al,'9'
        jbe l29
        or al,20h
        cmp al,'a'
        jb ld
        cmp al,'x'
        je l35
        cmp al,'p'
        je l35
        cmp al,'z'
        jbe l29
        jmp ld
l33:
        lc ASCIIWORD
        lodsb
        cmp al,'.'
        je l29
        cmp al,'_'
        je l29
        cmp al,'@'
        je l29
        cmp al,'0'
        jb ld
        cmp al,'9'
        jbe l29
        or al,20h
        cmp al,'a'
        jb ld
        cmp al,'x'
        je short l35
        cmp al,'i'
        je short l35
        cmp al,'z'
        jbe l29
        jmp ld
l34:
        lc ASCIIWORD
        lodsb
        cmp al,'.'
        je l29
        cmp al,'_'
        je l29
        cmp al,'@'
        je l29
        cmp al,'0'
        jb ld
        cmp al,'9'
        jbe l29
        or al,20h
        cmp al,'a'
        jb ld
        cmp al,'i'
        je short l35
        cmp al,'z'
        jbe l29
        jmp ld
l35:
        lc REG
        jmp l36

code32  ends
        end

